/****************************************************************************
	^C}Rg[p@MAT0.0NbNo̓TvvO
****************************************************************************/


/* CPU/荞ݐ֐wb_ */
#include "cpu_init.h"
#include "cpu_uart.h"
#include "io.h"

extern void _irq_process();

#define SET_SCLK(out){	*FGPIO_FIO0SET = 0x20; }

#define CLR_SCLK(out){	*FGPIO_FIO0SET = out;	*FGPIO_FIO0CLR =(0x20); }

#define CLR_GSCLK(){	*FGPIO_FIO1SET = 0x10000000; }
#define SET_GSCLK(){	*FGPIO_FIO1CLR = 0x10000000; }

#define CLR_XLAT(out){	*FGPIO_FIO0CLR =0x80; }
#define SET_XLAT(out){	*FGPIO_FIO0SET =0x80; }
#define ALLRESET() {	*FGPIO_FIO0CLR =(0x10); }

#define output(out) ""
#define ch_line() ""

#define SET_CTRLREG(){\
	*FGPIO_FIO0DIR = 0x000000f0;\
	*FGPIO_FIO1DIR = 0xf0000000;\
	*FGPIO_FIO2DIR = 0x000000ff;\
	*FGPIO_FIO2SET = 0x00000010;\
}
// 
//#define __ZERO_ARRAY 1
//#define __SS_ARRAY 1
//#define __FULL_ARRAY 1
//#define __A_ARRAY 1
//#define __FIVE_ARRAY 1
#define __ONE_ARRAY 1

#ifndef NEW
#define DATA_OUTPUT(){ out = (((array[i]) >>j) & 0x1 ) <<4;}
#endif

#define RED 2
#define GREEN 1
#define BLUE 3
#define RED_DATA 0
#define GREEN_DATA 1
#define BLUE_DATA 2


#define LINES 32
unsigned short data_array[1024]={
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,
	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff,	0xfff
	};

#ifdef __MIN_ARRAY
unsigned short array[32]={
	//NULL
	0x0f01,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,
	//Green
	0x000,	0xf01,	0x000,	0x000,	0x00f,	0x40f,	0x000,	0xfff,
	//Red
	0x00f,	0x00f,	0x00f,	0x000,	0x00f,	0x00f,	0x00f,	0x00f,
	//Blue
	0x001,	0x001,	0x001,	0x000,	0x001,	0x001,	0x001,	0x001
	};
#elif __FULL_ARRAY
unsigned short array[32]={
	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,
	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,
	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,
	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff,	0xffff
	};
#elif __SS_ARRAY
const unsigned short array[32]={
	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,
	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,
	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,
	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001
	};
#elif __ONE_ARRAY
const unsigned short array[32]={
	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,
	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,
	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,
	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001,	0x001
	};
#elif __ZERO_ARRAY
const unsigned short array[32]={
	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,
	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,
	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,
	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,	0x000,	0x000
	};
#elif __FIVE_ARRAY
unsigned short array[32]={
	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,
	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,
	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,
	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,	0x555,	0x555
	};
#elif __A_ARRAY
unsigned short array[32]={
	2048,	2048,	2048,	2048,	2048,	2048,	2048,	2048,
	2048,	2048,	2048,	2048,	2048,	2048,	2048,	2048,
	2048,	2048,	2048,	2048,	2048,	2048,	2048,	2048,
	2048,	2048,	2048,	2048,	2048,	2048,	2048,	2048
	};
#endif
extern char led_flg ;
static unsigned char line ;
unsigned char *tmp_array ;

/**
 * ^C}[荞݂ĂяoB
 * X_LATOUT𑗐MB
 * IC8bit̃f[^LED}gNXɏo͂B
 */
inline void X_LATOUT(){
	char k;
	static unsigned short new_line_tmp = 0;
	SET_XLAT(out);
	CLR_XLAT(out);
	*FGPIO_FIO2CLR = 0xff;
	*FGPIO_FIO2SET = line;
	line = line>>1;
	if(!line){
		line =0x80;
		new_line_tmp = 0 ;
	}
}

/**
 * NbN̏o͊֐
 */
inline void gs_clock(){
	int k;
	for(k=0;k<4096;k++){
		SET_GSCLK();
		CLR_GSCLK();
	}
}
/**
 * LED̏o͗p8Bit̃f[^𑗐MB
 * data_set_flgŃf[^̑MI肵ČĂяoB
 */
void led_seting_data(){
	short i, j, k, out;
	char cl,no,data_no;
	out = 0;
	//SET_CTRLREG();
	for(i =0; i<LINES; i++){
		data_no = (i>>3)&0x3;
		// RGBNGRB֕ёւ
		if(data_no == RED)data_no = RED_DATA;
		else if(data_no == GREEN)data_no = GREEN_DATA;
		else if(data_no == BLUE)data_no = BLUE_DATA;
		// Green̏ꍇ̂ݕтtȂ̂ 3*7 byteZ
		if((i&0x7)==0){
			if(data_no == GREEN) tmp_array = array + 21;
			else tmp_array = array ;
		}
		
		for(j = 11;j >= 0; j--){
			//o͂f[^outɃZbg
			DATA_OUTPUT();
			for(k=0;k<2;k++){
				if(k){
					//SCLKHɂ
					SET_SCLK(out);
				}else{
					//SINLɂ
					ALLRESET();
					//SCLKLɂăf[^H̏ꍇSINHɂ
					CLR_SCLK(out);
				}
			}
		}
		// Green̏ꍇ̂ݕтtȂ̂ŃfNg
		if(data_no == GREEN) tmp_array -= 3;
		else tmp_array += 3;

	}
}

static unsigned short  gs_clock_count = 0;
static char data_set_flg = 0;
/**
 * ^C}[荞݊֐
 */
void CPU_IRQInterrupt()
{
	*FGPIO_FIO0SET = 0x00000040;
	if(data_set_flg){
		X_LATOUT();
	}
	*FGPIO_FIO0CLR = 0x00000040;
	data_set_flg = 0;
	*TIMER_T1IR = 1;
}

/* MAT0.0o̓s NbNo͐vO */
char led_flg = 0;
int main(void)
{
	short k = 0;
	CPU_Initialize();
	CPU_UartInitialize();
	*TIMER_T0TCR = 0;	/* ^C}~*/
	*TIMER_T0TC = 0;
	*TIMER_T0IR = 1;		/* ^C}荞݃NA */
	CPU_UartPuts("aaaa\n");
	/* ^C}[2dON*/
	//*PCOMP = *PCOMP|1<<22;

	*SYS_SCS = *SYS_SCS | 1;	/* FGPIO Select */
	*VIC_IntSelect = 0;
	//	*VIC_IntEnable = VIC_INT_TIMER0;
	/* 荞݃Rg[ݒ */
	/* IRQI */
	*VIC_IntSelect = *VIC_IntSelect & VIC_INT_TIMER0 & VIC_INT_TIMER1;
	/* ^C}0̂ݗL */
	*VIC_IntEnable = *VIC_IntEnable | VIC_INT_TIMER0 | VIC_INT_TIMER1;
	*VIC_VectPriority5 = 1;
	*VIC_VectAddr5 = (void *)CPU_IRQInterrupt;
	
	/* NbNo̓sI */
	/* P1.28MAT0.0ƂĎgp(CN1 18ԃs) */
	*GPIO_PINSEL3 = (*GPIO_PINSEL3 & 0xFCFFFFFF) | 0x03000000;

	/* ^C}Rg[ւ̋NbNݒ */
	/* CPUNbNƓ(72MHz) */
	*CLK_PCLKSEL0 = (*CLK_PCLKSEL0 & 0xfffffff3) | (1 << 2);

	/* ^C}Rg[ */
	/* ^C}0̃p[^ݒ */
	*TIMER_T0PR  = 0x00000000;		/* vXP[ */
	*TIMER_T0MCR = 0x00000002;		/* MatchTCNA */
	/* 9MHzo */
//	*TIMER_T0MR0 = 1024 ;			/* 1/418MHz */
	*TIMER_T0MR0 = 3;			/* 1/418MHz */
	*TIMER_T0EMR = 0x00000030;		/* MAT0.0 gOó9MHz */
	
	/* ^C}2̃p[^ݒ */
	*TIMER_T1PR  = 0x00000000;		/* vXP[ */
	*TIMER_T1MCR = 0x00000003;		/* MatchTCNA 荞*/
	*TIMER_T1MR0 = 8192;			/* 1/418MHz */

	*FGPIO_FIO0DIR = 0x000000f0;
	*FGPIO_FIO1DIR = 0xf0000000;
	*FGPIO_FIO2DIR = 0x000000ff;

	CPU_UartPuts("start LedMatrix \n");
	CPU_EnableInterrupt();
	*TIMER_T0TCR = 1;			/* ^C}X^[g*/
	*TIMER_T1TCR = 1;			/* ^C}1X^[g*/

	for(;;){
		if(!data_set_flg){
			led_seting_data();
			data_set_flg = 1;
		}
		//*FGPIO_FIO1SET = 0x10000000;
		//*FGPIO_FIO1CLR = 0x10000000;
	}	/* [v */
}
