	.text

	.extern		main
	.extern		CPU_IRQInterrupt
	.extern		_sp_base
	.extern		_exception_sp_base
#==============================================================================
#      Initialize vectors
#
##     0x00 	 Reset
##     0x04 	 Undefined Instruction
##     0x08 	 Software Interrupt
##     0x0c 	 Abort(prefetch)
##     0x10 	 Abort(data)
##     0x14 	 Reserved
##     0x18 	 IRQ
##     0x1c 	 FIQ
#==============================================================================

	.org(0x00)

	B	_startup
	NOP
	NOP
	NOP
	NOP
	NOP
	B	_irq_process
	NOP

	.org(0x20)

_startup:
#vZbT[hIRQ[h
	MRS	R1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x12
	MSR	CPSR, R1
#IRQpX^bNݒ
	LDR	SP, = _exception_sp_base

#vZbT[hX[poCU[h֖߂
	ORR	R1, R1, #0x13
	MSR	CPSR, R1
#X[poCUpX^bNݒ
	LDR	SP, = _sp_base

#Cmain֐
	BL	main


#IRQ荞ݏnh
_irq_process:
# O
	STMFD	SP!,{R0-R12,LR}

# Cŏꂽ荞ݏɕ
	BL	CPU_IRQInterrupt

# ㏈
	LDMFD	SP!,{R0-R12,LR}
	SUBS	PC,LR,#4
